"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var assign = require("object-assign");
var FormSubmissionView = (function (_super) {
    __extends(FormSubmissionView, _super);
    function FormSubmissionView(props) {
        var _this = _super.call(this, props) || this;
        _this.renderField = _this.renderField.bind(_this);
        _this.onValueChanged = _this.onValueChanged.bind(_this);
        return _this;
    }
    FormSubmissionView.prototype.renderField = function (field, index) {
        var fieldDef = this.props.registry[field.type];
        if (!fieldDef || !fieldDef.render) {
            console.warn('Field defintion is not registered: ' + field.type);
            return;
        }
        var value = this.props.value[field.key];
        var component = React.createElement(fieldDef.render, {
            field: field,
            index: index,
            value: value,
            registry: this.props.registry,
            onValueChange: this.onValueChanged,
        });
        return (React.createElement("div", { className: 'form-submission-field', key: index }, component));
    };
    FormSubmissionView.prototype.onValueChanged = function (field, value) {
        var newValue = assign({}, this.props.value);
        newValue[field.key] = value;
        this.props.onChange(newValue);
    };
    // render displays a list of fields that have been wrapped in components for
    // providing editing, dragging, and dropping functionality. At the end of the list
    // is a <Droppable> field.
    FormSubmissionView.prototype.render = function () {
        return (React.createElement("div", { className: 'form-submission' }, this.props.fields.map(this.renderField)));
    };
    return FormSubmissionView;
}(React.PureComponent));
FormSubmissionView.defaultProps = {
    value: {}
};
exports.FormSubmissionView = FormSubmissionView;
