"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var FormSubmissionView_1 = require("./FormSubmissionView");
var NestedFormSubmissionView = (function (_super) {
    __extends(NestedFormSubmissionView, _super);
    function NestedFormSubmissionView(props) {
        var _this = _super.call(this, props) || this;
        _this.renderEntry = _this.renderEntry.bind(_this);
        _this.onCreateEntry = _this.onCreateEntry.bind(_this);
        _this.onDeleteEntry = _this.onDeleteEntry.bind(_this);
        _this.onEntryValueChanged = _this.onEntryValueChanged.bind(_this);
        return _this;
    }
    NestedFormSubmissionView.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement("button", { type: 'button', onClick: this.onCreateEntry }, "Create"),
            this.props.value.map(this.renderEntry)));
    };
    NestedFormSubmissionView.prototype.renderEntry = function (entry, index) {
        return (React.createElement(NestedFromEntry, { key: index, index: index, value: entry, fields: this.props.field.fields, registry: this.props.registry, onChange: this.onEntryValueChanged, onDelete: this.onDeleteEntry }));
    };
    NestedFormSubmissionView.prototype.onCreateEntry = function () {
        var entries = this.props.value.slice();
        entries.push({});
        this.props.onValueChange(this.props.field, entries);
    };
    NestedFormSubmissionView.prototype.onDeleteEntry = function (index) {
        var entries = this.props.value.slice();
        entries.splice(index, 1);
        this.props.onValueChange(this.props.field, entries);
    };
    NestedFormSubmissionView.prototype.onEntryValueChanged = function (value, index) {
        var newValue = this.props.value.slice();
        newValue[index] = value;
        this.props.onValueChange(this.props.field, newValue);
    };
    return NestedFormSubmissionView;
}(React.PureComponent));
NestedFormSubmissionView.defaultProps = {
    value: [{}]
};
exports.NestedFormSubmissionView = NestedFormSubmissionView;
var NestedFromEntry = (function (_super) {
    __extends(NestedFromEntry, _super);
    function NestedFromEntry() {
        var _this = _super.call(this) || this;
        _this.onValueChanged = _this.onValueChanged.bind(_this);
        _this.onDeleted = _this.onDeleted.bind(_this);
        return _this;
    }
    NestedFromEntry.prototype.render = function () {
        return (React.createElement("div", { className: 'form-submission-nested-entry' },
            React.createElement("button", { type: 'button', onClick: this.onDeleted }, "Delete"),
            React.createElement(FormSubmissionView_1.FormSubmissionView, { fields: this.props.fields, registry: this.props.registry, value: this.props.value, onChange: this.onValueChanged })));
    };
    NestedFromEntry.prototype.onDeleted = function () {
        this.props.onDelete(this.props.index);
    };
    NestedFromEntry.prototype.onValueChanged = function (value) {
        this.props.onChange(value, this.props.index);
    };
    return NestedFromEntry;
}(React.PureComponent));
